#include "adc_objects.h"
#include "built_in.h"


// TFT module connections
char TFT_16bit_DataPort_Hi at PORTC;
char TFT_16bit_DataPort_Lo at PORTA;
sbit TFT_16bit_RST at PORTJ6_bit;
sbit TFT_16bit_RS at PORTG2_bit;
sbit TFT_16bit_CS at PORTJ5_bit;
sbit TFT_16bit_RD at PORTG1_bit;
sbit TFT_16bit_WR at PORTG0_bit;
sbit TFT_16bit_BLED at PORTB4_bit;
char TFT_16bit_DataPort_Hi_Direction at DDRC;
char TFT_16bit_DataPort_Lo_Direction at DDRA;
sbit TFT_16bit_RST_Direction at DDJ6_bit;
sbit TFT_16bit_RS_Direction at DDG2_bit;
sbit TFT_16bit_CS_Direction at DDJ5_bit;
sbit TFT_16bit_RD_Direction at DDG1_bit;
sbit TFT_16bit_WR_Direction at DDG0_bit;
sbit TFT_16bit_BLED_Direction at DDB4_bit;
// End TFT module connections

// Touch Panel module connections
sbit DRIVEX_LEFT at PORTF0_bit;
sbit DRIVEX_RIGHT at PORTE2_bit;
sbit DRIVEY_UP at PORTE3_bit;
sbit DRIVEY_DOWN at PORTF1_bit;
sbit DRIVEX_LEFT_DIRECTION at DDF0_bit;
sbit DRIVEX_RIGHT_DIRECTION at DDE2_bit;
sbit DRIVEY_UP_DIRECTION at DDE3_bit;
sbit DRIVEY_DOWN_DIRECTION at DDF1_bit;
// End Touch Panel module connections

// Global variables
unsigned int Xcoord, Ycoord;
const ADC_THRESHOLD = 900;
char PenDown;
typedef unsigned long TPointer;
TPointer PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;

static void InitializeTouchPanel() {
  TFT_Init_HX8347D(320, 240);

}


/////////////////////////
  TScreen*  CurrentScreen;

  TScreen                Screen1;




static void InitializeObjects() {
  Screen1.Color                     = 0x0000;
  Screen1.Width                     = 320;
  Screen1.Height                    = 240;
  Screen1.ObjectsCount              = 0;

}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) { // static
  if ( (Left<= X) && (Left+ Width - 1 >= X) &&
       (Top <= Y)  && (Top + Height - 1 >= Y) )
    return 1;
  else
    return 0;
}



 void DeleteTrailingSpaces(char* str){
   char i;
   i = 0;
   while(1) {
   if(str[0] == ' ') {
      for(i = 0; i < strlen(str); i++) {
       str[i] = str[i+1];
      }
   }
   else
     break;
  }
 }

void DrawScreen(TScreen *aScreen) {
 int order;
  char save_bled, save_bled_direction;

  object_pressed = 0;
  order = 0;
  CurrentScreen = aScreen;

  if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
    save_bled = TFT_16bit_BLED;
    save_bled_direction = TFT_16bit_BLED_Direction;
    TFT_16bit_BLED_Direction = 1;
    TFT_16bit_BLED           = 0;
    TFT_Init_HX8347D(CurrentScreen->Width, CurrentScreen->Height);
    TFT_16bit_Fill_Screen(CurrentScreen->Color);
    display_width = CurrentScreen->Width;
    display_height = CurrentScreen->Height;
    TFT_16bit_BLED           = save_bled;
    TFT_16bit_BLED_Direction = save_bled_direction;
  }
  else
    TFT_16bit_Fill_Screen(CurrentScreen->Color);


  while (order < CurrentScreen->ObjectsCount) {
  }
}

void Init_MCU() {
  // TP_TFT_Rotate_180(0);
}

void Start_TP() {
  Init_MCU();

  InitializeTouchPanel();

  InitializeObjects();
  display_width = Screen1.Width;
  display_height = Screen1.Height;
  DrawScreen(&Screen1);
}