/*
 * Project name:
     adc.vtft
 * Generated by:
     Visual TFT
 * Date of creation
     19.10.2012
 * Time of creation
     20:51:22
 * Test configuration:
     MCU:             ATmega1280
     Dev.Board:       mikromedia_for_ATmega
                      http://www.mikroe.com/eng/products/view/797/mikromedia-for-atmega/
     Oscillator:      8000000 Hz
     SW:              mikroC PRO for AVR
                      http://www.mikroe.com/eng/products/view/228/mikroc-pro-for-avr/
 */

#include "adc_objects.h"

sbit Chip_Select_Direction at DDL2_bit;
sbit Chip_Select at PORTL2_bit;
float measurement1, measurement2, measurement3, measurement4;
char measuremen1[16], measuremen2[16], measuremen3[16], measuremen4[16];

void print_adc() {
  TFT_16bit_Set_Font(&TFT_16bit_defaultFont, CL_WHITE_16bit, FO_HORIZONTAL_16bit);
  TFT_16bit_Set_Pen(CL_Black_16bit, 42);
  TFT_16bit_Line(170, 73, 245, 73);
  TFT_16bit_Write_Text(measuremen1, 170, 50);
  TFT_16bit_Write_Text(measuremen2, 170, 60);
  TFT_16bit_Write_Text(measuremen3, 170, 70);
  TFT_16bit_Write_Text(measuremen4, 170, 80);
  Delay_ms(1000);
}


void init_adc() {

  measurement1 = 0;
  measurement2 = 0;
  measurement3 = 0;
  measurement4 = 0;                               // Initialize the measurement variable

// Init SPI
  SPI1_Init_Advanced(_SPI_MASTER,                // Initialize AVR as master
                     _SPI_FCY_DIV64,             // Data sample at end
                     _SPI_CLK_LO_LEADING);

  Chip_Select_Direction = 1;                     // SetBit(DDRB,0)
  Chip_Select= 1;                                // SetBit(PORTB,0)
}//~


float getADC(unsigned short channel) {    // Returns 0..4095
  unsigned int tmp;
  Chip_Select= 0;                                // Select MCP3204
  SPI1_Write(0x06);                              // SPI communication using 8-bit segments
  channel = channel << 6;                        // Bits 7 & 6 define ADC input
  tmp = SPI1_Read(channel) & 0x0F;
  tmp = tmp << 8;                                // Get ADC value
  tmp |= SPI1_Read(0);
  Chip_Select= 1;
  return tmp;
}//~


void adc_read() {

     measurement1 = (getADC(0)+3.0)/1000.0;
     sprintf(measuremen1, "%2.2f", measurement1);

     measurement2 = (getADC(1)+6.0)/1000.0;
     sprintf(measuremen2, "%2.3f", measurement2);

     measurement3 = (getADC(2)+3.0)/1000.0;
     sprintf(measuremen3, "%2.3f", measurement3);

     measurement4 = (getADC(3)+3.0)/1000.0;
     sprintf(measuremen4, "%2.3f", measurement4);


}


void main() {
  Start_TP();
  DDB4_bit = 1;  // PWM2  PIN-out LED_LCD
  PWM2_Init(_PWM2_FAST_MODE, _PWM2_PRESCALER_1 , _PWM2_NON_INVERTED, 50); // 50 = 20% - brightness LED control the display 1 to 255
  PWM2_Start(); // start PWM2
  
  init_adc();

  while (1) {
   adc_read();
   print_adc();

  }

}